<?php
/**
* SYNTAX HIGHLIGHTER using SyntaxHighlighter (http://alexgorbatchev.com/wiki/SyntaxHighlighter)
*
* version: 1.0
* Syntax Highlighter version: 2.0.296
*
* usage : [code:js]...[/code]
* usage : [code:bash]...[/code]
* usage : [code:cpp]...[/code]
* usage : [code:php]...[/code]
* ... anything if you want  :)
*
* available class list :
*		Type				: class name
*		------------------------------------------------
*		Bash/shell		: bash, shell
*		C#					: c-sharp, csharp
*		C++				: cpp, c
*		CSS					: css
*		Delphi				: delphi, pas, pascal
*		Diff					: diff, patch
*		Groovy			: groovy
*		JavaScript	: js, jscript, javascript
*		Java				: java
*		Perl					: perl, pl
*		PHP					: php
*		Plain				: Text  plain, text
*		Python			: py, python
*		Ruby				: rails, ror, ruby
*		Scala				: scala
*		SQL					: sql
*		Visual Basic	: vb, vbnet
*		XML					: xml, xhtml, xslt, html, xhtml
*
* made by manu(http://manuz.com)
* based on eye(http://theeye.pe.kr)'s plugin. THX :D
*/

function lf_SyntaxHighlighterDataSet($data){
	requireComponent('Textcube.Function.misc');
	$cfg = misc::fetchConfigVal($data);
	return true;
}

function lf_SyntaxHighlighterContent($target, $mother)
{
	$ls_searchPattern = array(
		'/\[code\:(.*?)\](.*?)\[\/code\]/is'
		);
	$ls_replacePattern = array(
		'<pre class="brush:$1;">$2</pre>'
		);
	$result = preg_replace($ls_searchPattern, $ls_replacePattern, $target);
	return $result;
}

function lf_SyntaxHighlighterHeader($target)
{

	global $pluginURL, $configVal;
	requireComponent('Textcube.Function.misc');
	$data = misc::fetchConfigVal($configVal);

	// Config
	$ls_useSyntax = isset($data['useSyntax'])? $data['useSyntax'] : "true";
	$ls_useToolbar = isset($data['useToolbar'])? $data['useToolbar'] : "true";
	//$li_ToolbarSizeWidth = isset($data['ToolbarSizeWidth'])? $data['ToolbarSizeWidth'] : "16";
	//$li_ToolbarSizeWidth = isset($data['ToolbarSizeHeight'])? $data['ToolbarSizeHeight'] : "16";
	$ls_useClipboard = isset($data['useClipboard'])? $data['useClipboard'] : "true";

	// Design
	$ls_Theme = isset($data['Theme'])? $data['Theme'] : "Default";
	$ls_FontSize = isset($data['FontSize'])? $data['FontSize'] : "100%";
	$ls_useGutter = isset($data['useGutter'])? $data['useGutter'] : "true";
	$ls_useHTMLScript = isset($data['useHTMLScript'])? $data['useHTMLScript'] : "true";
	$ls_useAutoLinks = isset($data['useAutoLinks'])? $data['useAutoLinks'] : "true";
	$ls_useRuler = isset($data['useRuler'])? $data['useRuler'] : "false";
	$ls_useSmartTab = isset($data['useSmartTab'])? $data['useSmartTab'] : "true";
	$ls_TabSize = isset($data['TabSize'])? $data['TabSize'] : "4";

	// Message
	$ls_STRviewSource = isset($data['STRviewSource'])? $data['STRviewSource'] : "view source";
	$ls_STRcopyToClipboard = isset($data['STRcopyToClipboard'])? $data['STRcopyToClipboard'] : "copy to clipboard";
	$ls_STRcopyToClipboardConfirmation = isset($data['STRcopyToClipboardConfirmation'])? $data['STRcopyToClipboardConfirmation'] : "The code is in your clipboard now";
	$ls_STRprint = isset($data['STRprint'])? $data['STRprint'] : "print";
	$ls_STRhelp = isset($data['STRhelp'])? $data['STRhelp'] : "?";
	$ls_STRalert = isset($data['STRalert'])? $data['STRalert'] : "SyntaxHighlighter by Manu\n\n";
	$ls_STRnoBrush = isset($data['STRnoBrush'])? $data['STRnoBrush'] : "Can't find brush for: ";
	$ls_STRbrushNotHtmlScript = isset($data['STRbrushNotHtmlScript'])? $data['STRbrushNotHtmlScript'] : "Brush wasn't made for html-script option: ";

	if($ls_useSyntax == "true") {
		$content  = "<link type=\"text/css\" rel=\"stylesheet\" href=\"$pluginURL/styles/shCore.css\" />";
		$content  .= "<link type=\"text/css\" rel=\"stylesheet\" href=\"$pluginURL/styles/shTheme$ls_Theme.css\" />";
		$content  .= "<script type=\"text/javascript\" src=\"$pluginURL/scripts/shCore.js\"></script>";
		$content  .= "<script type=\"text/javascript\" src=\"$pluginURL/scripts/shBrushBash.js\"></script>";
		$content  .= "<script type=\"text/javascript\" src=\"$pluginURL/scripts/shBrushCSharp.js\"></script>";
		$content  .= "<script type=\"text/javascript\" src=\"$pluginURL/scripts/shBrushCpp.js\"></script>";
		$content  .= "<script type=\"text/javascript\" src=\"$pluginURL/scripts/shBrushCss.js\"></script>";
		$content  .= "<script type=\"text/javascript\" src=\"$pluginURL/scripts/shBrushDelphi.js\"></script>";
		$content  .= "<script type=\"text/javascript\" src=\"$pluginURL/scripts/shBrushDiff.js\"></script>";
		$content  .= "<script type=\"text/javascript\" src=\"$pluginURL/scripts/shBrushGroovy.js\"></script>";
		$content  .= "<script type=\"text/javascript\" src=\"$pluginURL/scripts/shBrushJScript.js\"></script>";
		$content  .= "<script type=\"text/javascript\" src=\"$pluginURL/scripts/shBrushJava.js\"></script>";
		$content  .= "<script type=\"text/javascript\" src=\"$pluginURL/scripts/shBrushPerl.js\"></script>";
		$content  .= "<script type=\"text/javascript\" src=\"$pluginURL/scripts/shBrushPhp.js\"></script>";
		$content  .= "<script type=\"text/javascript\" src=\"$pluginURL/scripts/shBrushPlain.js\"></script>";
		$content  .= "<script type=\"text/javascript\" src=\"$pluginURL/scripts/shBrushPython.js\"></script>";
		$content  .= "<script type=\"text/javascript\" src=\"$pluginURL/scripts/shBrushRuby.js\"></script>";
		$content  .= "<script type=\"text/javascript\" src=\"$pluginURL/scripts/shBrushScala.js\"></script>";
		$content  .= "<script type=\"text/javascript\" src=\"$pluginURL/scripts/shBrushSql.js\"></script>";
		$content  .= "<script type=\"text/javascript\" src=\"$pluginURL/scripts/shBrushVb.js\"></script>";
		$content  .= "<script type=\"text/javascript\" src=\"$pluginURL/scripts/shBrushXml.js\"></script>";

		$content  .= "<script type=\"text/javascript\">";
		if($ls_useClipboard == "true") $content  .= "SyntaxHighlighter.config.clipboardSwf = '$pluginURL/scripts/clipboard.swf'; ";
		//$content  .= "SyntaxHighlighter.config.toolbarItemWidth  = '$li_ToolbarSizeWidth'; ";
		//$content  .= "SyntaxHighlighter.config.toolbarItemHeight   = '$li_ToolbarSizeHeight'; ";
		$content  .= "SyntaxHighlighter.config.strings.viewSource = \"$ls_STRviewSource\"; ";
		$content  .= "SyntaxHighlighter.config.strings.copyToClipboard = \"$ls_STRcopyToClipboard\"; ";
		$content  .= "SyntaxHighlighter.config.strings.copyToClipboardConfirmation = \"$ls_STRcopyToClipboardConfirmation\"; ";
		$content  .= "SyntaxHighlighter.config.strings.print = \"$ls_STRprint\"; ";
		$content  .= "SyntaxHighlighter.config.strings.help = \"$ls_STRhelp\"; ";
		$content  .= "SyntaxHighlighter.config.strings.alert = \"$ls_STRalert\"; ";
		$content  .= "SyntaxHighlighter.config.strings.noBrush = \"$ls_STRnoBrush\"; ";
		$content  .= "SyntaxHighlighter.config.strings.brushNotHtmlScript = \"$ls_STRbrushNotHtmlScript\"; ";

		$content  .= "SyntaxHighlighter.defaults['auto-links'] = $ls_useAutoLinks; ";
		$content  .= "SyntaxHighlighter.defaults['font-size'] = '$ls_FontSize'; ";
		$content  .= "SyntaxHighlighter.defaults['gutter'] = $ls_useGutter; ";
		$content  .= "SyntaxHighlighter.defaults['html-script'] = $ls_useHTMLScript; ";
		$content  .= "SyntaxHighlighter.defaults['ruler'] = $ls_useRuler; ";
		$content  .= "SyntaxHighlighter.defaults['smart-tabs'] = $ls_useSmartTab; ";
		$content  .= "SyntaxHighlighter.defaults['tab-size']= $ls_TabSize; ";
		$content  .= "SyntaxHighlighter.defaults['toolbar'] = \"$ls_useToolbar\"; ";

		$content  .= "	SyntaxHighlighter.all();";
		$content  .= "</script>";
	}
	return $target.$content;
}

?>
